app/Models/Pirep.php
<?php

namespace App\Models;

use App\Contracts\Model;
use App\Models\Enums\AcarsType;
use App\Models\Enums\PirepFieldSource;
use App\Models\Enums\PirepState;
use App\Models\Traits\HashIdTrait;
use App\Support\Units\Distance;
use App\Support\Units\Fuel;
use Carbon\Carbon;
use Illuminate\Support\Collection;

/**
 * @property string      id
 * @property string      ident
 * @property string      flight_number
 * @property string      route_code
 * @property string      route_leg
 * @property string      flight_type
 * @property int         airline_id
 * @property int         user_id
 * @property int         aircraft_id
 * @property Aircraft    aircraft
 * @property Airline     airline
 * @property Airport     arr_airport
 * @property string      arr_airport_id
 * @property Airport     dpt_airport
 * @property string      dpt_airport_id
 * @property Carbon      block_off_time
 * @property Carbon      block_on_time
 * @property int         block_time
 * @property int         flight_time    In minutes
 * @property int         planned_flight_time
 * @property float       block_fuel
 * @property float       fuel_used
 * @property float       distance
 * @property float       planned_distance
 * @property int         level
 * @property string      route
 * @property int         score
 * @property User        user
 * @property Flight|null flight
 * @property Collection  fields
 * @property string      status
 * @property bool        state
 * @property string      source
 * @property Carbon      submitted_at
 * @property Carbon      created_at
 * @property Carbon      updated_at
 * @property bool        read_only
 * @property Acars       position
 * @property Acars[]     acars
 * @property mixed       cancelled
 */
class Pirep extends Model
{
    use HashIdTrait;

    public $table = 'pireps';

    protected $keyType = 'string';
    public $incrementing = false;

    /** The form wants this */
    public $hours;
    public $minutes;

    protected $fillable = [
        'id',
        'user_id',
        'airline_id',
        'aircraft_id',
        'flight_number',
        'route_code',
        'route_leg',
        'flight_id',
        'dpt_airport_id',
        'arr_airport_id',
        'alt_airport_id',
        'level',
        'distance',
        'planned_distance',
        'block_time',
        'flight_time',
        'planned_flight_time',
        'zfw',
        'block_fuel',
        'fuel_used',
        'landing_rate',
        'route',
        'notes',
        'score',
        'source',
        'source_name',
        'flight_type',
        'state',
        'status',
        'block_off_time',
        'block_on_time',
        'submitted_at',
        'created_at',
        'updated_at',
    ];

    protected $casts = [
        'user_id'             => 'integer',
        'airline_id'          => 'integer',
        'aircraft_id'         => 'integer',
        'level'               => 'integer',
        'distance'            => 'float',
        'planned_distance'    => 'float',
        'block_time'          => 'integer',
        'flight_time'         => 'integer',
        'planned_flight_time' => 'integer',
        'zfw'                 => 'float',
        'block_fuel'          => 'float',
        'fuel_used'           => 'float',
        'landing_rate'        => 'float',
        'score'               => 'integer',
        'source'              => 'integer',
        'state'               => 'integer',
    ];

    public static $rules = [
        'airline_id'     => 'required|exists:airlines,id',
        'aircraft_id'    => 'required|exists:aircraft,id',
        'flight_number'  => 'required',
        'dpt_airport_id' => 'required',
        'arr_airport_id' => 'required',
        'block_fuel'     => 'nullable|numeric',
        'fuel_used'      => 'nullable|numeric',
        'level'          => 'nullable|numeric',
        'notes'          => 'nullable',
        'route'          => 'nullable',
    ];

    /*
     * If a PIREP is in these states, then it can't be changed.
     */
    public static $read_only_states = [
        PirepState::ACCEPTED,
        PirepState::REJECTED,
        PirepState::CANCELLED,
    ];

    /*
     * If a PIREP is in one of these states, it can't be cancelled
     */
    public static $cancel_states = [
        PirepState::ACCEPTED,
        PirepState::REJECTED,
        PirepState::CANCELLED,
        PirepState::DELETED,
    ];

    /**
     * Create a new PIREP model from a given flight. Pre-populates the fields
     *
     * @param \App\Models\Flight $flight
     *
     * @return \App\Models\Pirep
     */
    public static function fromFlight(Flight $flight): self
    {
        return new self([
            'flight_id'      => $flight->id,
            'airline_id'     => $flight->airline_id,
            'flight_number'  => $flight->flight_number,
            'route_code'     => $flight->route_code,
            'route_leg'      => $flight->route_leg,
            'dpt_airport_id' => $flight->dpt_airport_id,
            'arr_airport_id' => $flight->arr_airport_id,
            'route'          => $flight->route,
            'level'          => $flight->level,
        ]);
    }

    /**
     * Create a new PIREP from a SimBrief instance
     *
     * @param \App\Models\SimBrief $simBrief
     *
     * @return \App\Models\Pirep
     */
    public static function fromSimBrief(SimBrief $simBrief): self
    {
        return new self([
            'flight_id'      => $simBrief->flight->id,
            'airline_id'     => $simBrief->flight->airline_id,
            'flight_number'  => $simBrief->flight->flight_number,
            'route_code'     => $simBrief->flight->route_code,
            'route_leg'      => $simBrief->flight->route_leg,
            'dpt_airport_id' => $simBrief->flight->dpt_airport_id,
            'arr_airport_id' => $simBrief->flight->arr_airport_id,
            'route'          => $simBrief->xml->getRouteString(),
            'level'          => $simBrief->xml->getFlightLevel(),
        ]);
    }

    /**
     * Get the flight ident, e.,g JBU1900
     *
     * @return string
     */
    public function getIdentAttribute(): string
    {
        //$flight_id = $this->airline->code;
        $flight_id = $this->flight_number;

        if (filled($this->route_code)) {
            $flight_id .= '/C'.$this->route_code;
        }

        if (filled($this->route_leg)) {
            $flight_id .= '/L'.$this->route_leg;
        }

        return $flight_id;
    }

    /**
     * Return the block off time in carbon format
     *
     * @return Carbon|null
     */
    public function getBlockOffTimeAttribute()
    {
        if (array_key_exists('block_off_time', $this->attributes)) {
            return new Carbon($this->attributes['block_off_time']);
        }
    }

    /**
     * Return the block on time
     *
     * @return Carbon|null
     */
    public function getBlockOnTimeAttribute()
    {
        if (array_key_exists('block_on_time', $this->attributes)) {
            return new Carbon($this->attributes['block_on_time']);
        }
    }

    /**
     * Return the block on time
     *
     * @return Carbon
     */
    public function getSubmittedAtAttribute()
    {
        if (array_key_exists('submitted_at', $this->attributes)) {
            return new Carbon($this->attributes['submitted_at']);
        }
    }

    /**
     * Set the distance unit, convert to our internal default unit
     *
     * @param $value
     */
    public function setDistanceAttribute($value): void
    {
        if ($value instanceof Distance) {
            $this->attributes['distance'] = $value->toUnit(
                config('phpvms.internal_units.distance')
            );
        } else {
            $this->attributes['distance'] = $value;
        }
    }

    /**
     * Return if this PIREP can be edited or not
     */
    public function getReadOnlyAttribute(): bool
    {
        return \in_array($this->state, static::$read_only_states, true);
    }

    /**
     * Return the flight progress in a percent.
     */
    public function getProgressPercentAttribute()
    {
        $distance = $this->distance;

        $upper_bound = $distance;
        if ($this->planned_distance) {
            $upper_bound = $this->planned_distance;
        }

        $upper_bound = empty($upper_bound) ? 1 : $upper_bound;
        $distance = empty($distance) ? $upper_bound : $distance;

        return round(($distance / $upper_bound) * 100, 0);
    }

    /**
     * Get the pirep_fields and then the pirep_field_values and
     * merge them together. If a field value doesn't exist then add in a fake one
     */
    public function getFieldsAttribute()
    {
        $custom_fields = PirepField::all();
        $field_values = PirepFieldValue::where('pirep_id', $this->id)
            ->orderBy('created_at', 'asc')
            ->get();

        // Merge the field values into $fields
        foreach ($custom_fields as $field) {
            $has_value = $field_values->firstWhere('slug', $field->slug);
            if (!$has_value) {
                $field_values->push(new PirepFieldValue([
                    'pirep_id' => $this->id,
                    'name'     => $field->name,
                    'slug'     => $field->slug,
                    'value'    => '',
                    'source'   => PirepFieldSource::MANUAL,
                ]));
            }
        }

        return $field_values;
    }

    /**
     * Set the amount of block fuel
     *
     * @param $value
     */
    public function setBlockFuelAttribute($value): void
    {
        if ($value instanceof Fuel) {
            $this->attributes['block_fuel'] = $value->toUnit(
                config('phpvms.internal_units.fuel')
            );
        } else {
            $this->attributes['block_fuel'] = $value;
        }
    }

    /**
     * Set the amount of fuel used
     *
     * @param $value
     */
    public function setFuelUsedAttribute($value): void
    {

resources/views/layouts/default/pireps/create.blade.php
@extends('app')
@section('title', __('pireps.fileflightreport'))

@section('content')
  <div class="row">
    <div class="col-md-12">
      <h2>@lang('pireps.newflightreport')</h2>
      @include('flash::message')
      @if(!empty($pirep))
        {{ Form::model($pirep, ['route' => 'frontend.pireps.store']) }}
      @else
        {{ Form::open(['route' => 'frontend.pireps.store']) }}
      @endif

      @include('pireps.fields')

      {{ Form::close() }}
    </div>
  </div>
@endsection

@include('pireps.scripts')

resources/views/layouts/default/pireps/custom_fields.blade.php
<tr>
  <td>
    {{ $field->name }}
    @if($field->required === true)
      <span class="text-danger">*</span>
    @endif
  </td>
  <td>
    <div class="input-group input-group-sm form-group">
      @if(!$field->read_only)
        {{ Form::text($field->slug, $field->value, [
            'class' => 'form-control',
            'readonly' => (!empty($pirep) && $pirep->read_only),
            ]) }}
      @else
        {{ $field->value }}
      @endif
    </div>
    <p class="text-danger">{{ $errors->first('field_'.$field->slug) }}</p>
  </td>
</tr>

resources/views/layouts/default/pireps/edit.blade.php
@extends('app')
@section('title', __('pireps.editflightreport'))
@section('content')
  <div class="row">
    <div class="col-md-12">
      <h2>@lang('pireps.editflightreport')</h2>
      @include('flash::message')
      {{ Form::model($pirep, [
              'route' => ['frontend.pireps.update', $pirep->id],
              'class' => 'form-group',
              'method' => 'patch']) }}

      @include('pireps.fields')

      {{ Form::close() }}
    </div>
  </div>
@endsection
@include('pireps.scripts')

resources/views/layouts/default/pireps/fares.blade.php
@if($aircraft)
  <div class="form-container">
    <h6><i class="fas fa-ellipsis-h"></i>
      &nbsp;{{ trans_choice('pireps.fare', 2) }}
    </h6>
    <div class="form-container-body">
      @foreach($aircraft->subfleet->fares as $fare)
        <div class="row">
          <div class="col">
            {{Form::label('fare_'.$fare->id, $fare->name.' ('. \App\Models\Enums\FareType::label($fare->type).', code '.$fare->code.')')}}
            <div class="input-group form-group">
              {{ Form::number('fare_'.$fare->id, $fare->count, ['class' => 'form-control', 'min' => 0]) }}
            </div>
          </div>
        </div>
      @endforeach
    </div>
  </div>
@endif

resources/views/layouts/default/pireps/index.blade.php
@extends('app')
@section('title', trans_choice('common.pirep', 2))

@section('content')
  <div class="row">
    <div class="col-md-12">
      <div style="float:right;">
        <a class="btn btn-outline-info pull-right btn-lg"
           style="margin-top: -10px;margin-bottom: 5px"
           href="{{ route('frontend.pireps.create') }}">@lang('pireps.filenewpirep')</a>
      </div>
      <h2>{{ trans_choice('pireps.pilotreport', 2) }}</h2>
      @include('flash::message')
      @include('pireps.table')
    </div>
  </div>
  <div class="row">
    <div class="col-12 text-center">
      {{ $pireps->links('pagination.default') }}
    </div>
  </div>
@endsection

resources/views/layouts/default/pireps/map.blade.php
<div class="row">
  <div class="col-12">
    <div class="box-body">
      <div id="map" style="width: 100%; height: 800px"></div>
    </div>
  </div>
</div>

@section('scripts')
  <script type="text/javascript">
    phpvms.map.render_route_map({
      pirep_uri: '{!! url('/api/pireps/'.$pirep->id.'/acars/geojson') !!}',
      route_points: {!! json_encode($map_features['planned_rte_points'])  !!},
      planned_route_line: {!! json_encode($map_features['planned_rte_line']) !!},
      actual_route_line: {!! json_encode($map_features['actual_route_line']) !!},
      actual_route_points: {!! json_encode($map_features['actual_route_points']) !!},
      aircraft_icon: '{!! public_asset('/assets/img/acars/aircraft.png') !!}',
      leafletOptions: {
        scrollWheelZoom: false,
      }
    });
  </script>
@endsection

resources/views/layouts/default/pireps/scripts.blade.php
@section('scripts')
  <script>
    const select_id = "select#aircraft_select";
    const destContainer = $('#fares_container');

    $(select_id).change(e => {
      const aircraft_id = $(select_id + ' option:selected').val();
      const url = '/pireps/fares?aircraft_id=' + aircraft_id;
      console.log('aircraft select change: ', aircraft_id);

      phpvms.request(url).then(response => {
        destContainer.html(response.data);
      });
    });
  </script>
@endsection

resources/views/layouts/default/pireps/show.blade.php
@extends('app')
@section('title', trans_choice('common.pirep', 1).' '.$pirep->ident)

@section('content')
  <div class="row">
    <div class="col-sm-8">
      <h2>{{ $pirep->airline->icao }}{{ $pirep->ident }}
        : {{ $pirep->dpt_airport_id }} to {{ $pirep->arr_airport_id }}</h2>
    </div>

    <div class="col-sm-4">
      {{-- Show the link to edit if it can be edited --}}
      @if (!empty($pirep->simbrief))
        <a href="{{ url(route('frontend.simbrief.briefing', [$pirep->simbrief->id])) }}"
           class="btn btn-outline-info">View SimBrief</a>
      @endif

      @if(!$pirep->read_only)
        <div class="float-right" style="margin-bottom: 10px;">
          <form method="get"
                action="{{ route('frontend.pireps.edit', $pirep->id) }}"
                style="display: inline">
            @csrf
            <button class="btn btn-outline-info">@lang('common.edit')</button>
          </form>
          &nbsp;
          <form method="post"
                action="{{ route('frontend.pireps.submit', $pirep->id) }}"
                style="display: inline">
            @csrf
            <button class="btn btn-outline-success">@lang('common.submit')</button>
          </form>
        </div>
      @endif
    </div>
  </div>

  <div class="row">
    <div class="col-8">
      <div class="row">
        {{--
            DEPARTURE INFO
        --}}
        <div class="col-6 text-left">
          <h4>
            {{$pirep->dpt_airport->location}}
          </h4>
          <p>
            <a href="{{route('frontend.airports.show', $pirep->dpt_airport_id)}}">
              {{ $pirep->dpt_airport->full_name }} ({{  $pirep->dpt_airport_id }})</a>
            <br/>
            @if($pirep->block_off_time)
              {{ $pirep->block_off_time->toDayDateTimeString() }}
            @endif
          </p>
        </div>

        {{--
            ARRIVAL INFO
        --}}
        <div class="col-6 text-right">
          <h4>
            {{$pirep->arr_airport->location}}
          </h4>
          <p>
            <a href="{{route('frontend.airports.show', $pirep->arr_airport_id)}}">
              {{ $pirep->arr_airport->full_name }} ({{  $pirep->arr_airport_id }})</a>
            <br/>
            @if($pirep->block_on_time)
              {{ $pirep->block_on_time->toDayDateTimeString() }}
            @endif
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-12">
          <div class="progress" style="margin: 20px 0;">
            <div class="progress-bar progress-bar-success" role="progressbar"
                 aria-valuenow="40" aria-valuemin="0" aria-valuemax="100"
                 style="width: {{$pirep->progress_percent}}%;">
            </div>
          </div>
        </div>
      </div>

      <div class="row">
        <div class="col-12">
          @include('pireps.map')
        </div>
      </div>
    </div>

    {{--

    RIGHT SIDEBAR

    --}}

    <div class="col-4">
      <table class="table table-striped">
        <tr>
          <td width="30%">@lang('common.state')</td>
          <td>
            <div class="badge badge-info">
              {{ PirepState::label($pirep->state) }}
            </div>
          </td>
        </tr>

        @if ($pirep->state !== PirepState::DRAFT)
        <tr>
          <td width="30%">@lang('common.status')</td>
          <td>
            <div class="badge badge-info">
              {{ PirepStatus::label($pirep->status) }}
            </div>
          </td>
        </tr>
        @endif

        <tr>
          <td>@lang('pireps.source')</td>
          <td>{{ PirepSource::label($pirep->source) }}</td>
        </tr>

        <tr>
          <td>@lang('flights.flighttype')</td>
          <td>{{ \App\Models\Enums\FlightType::label($pirep->flight_type) }}</td>
        </tr>

        <tr>
          <td>@lang('pireps.filedroute')</td>
          <td>{{ $pirep->route }}</td>
        </tr>

        <tr>
          <td>{{ trans_choice('common.note', 2) }}</td>
          <td>{{ $pirep->notes }}</td>
        </tr>

        @if($pirep->score && $pirep->landing_rate)
          <tr>
            <td>Score</td>
            <td>{{ $pirep->score }}</td>
          </tr>
          <tr>
            <td>Landing Rate</td>
            <td>{{ number_format($pirep->landing_rate) }}</td>
          </tr>
        @endif

        <tr>
          <td>@lang('pireps.filedon')</td>
          <td>{{ show_datetime($pirep->created_at) }}</td>
        </tr>

      </table>

      @if(count($pirep->fields) > 0)
        <div class="separator"></div>
      @endif

      @if(count($pirep->fields) > 0)
        <h5>{{ trans_choice('common.field', 2) }}</h5>
        <table class="table table-hover table-condensed">
          <thead>
          <th>@lang('common.name')</th>
          <th>{{ trans_choice('common.value', 1) }}</th>
          </thead>
          <tbody>
          @foreach($pirep->fields as $field)
            <tr>
              <td>{{ $field->name }}</td>
              <td>{{ $field->value }}</td>
            </tr>
          @endforeach
          </tbody>
        </table>
      @endif

      @if(count($pirep->fares) > 0)
        <div class="separator"></div>
      @endif

      {{--
          Show the fares that have been entered
      --}}
      @if(count($pirep->fares) > 0)
        <div class="row">
          <div class="col-12">
            <h5>{{ trans_choice('pireps.fare', 2) }}</h5>
            <table class="table table-hover table-condensed">
              <thead>
              <th>@lang('pireps.class')</th>
              <th>@lang('pireps.count')</th>
              </thead>
              <tbody>
              @foreach($pirep->fares as $fare)
                <tr>
                  <td>{{ $fare->fare->name }} ({{ $fare->fare->code }})</td>
                  <td>{{ $fare->count }}</td>
                </tr>
              @endforeach
              </tbody>
            </table>
          </div>
        </div>
      @endif
    </div>
  </div>

  @if(count($pirep->acars_logs) > 0)
    <div class="separator"></div>
    <div class="row">
      <div class="col-12">
        <h5>@lang('pireps.flightlog')</h5>
      </div>
      <div class="col-12">
        <table class="table table-hover table-condensed" id="users-table">
          <tbody>
          @foreach($pirep->acars_logs->sortBy('created_at') as $log)
            <tr>
              <td nowrap="true">{{ show_datetime($log->created_at) }}</td>
              <td>{{ $log->log }}</td>
            </tr>
          @endforeach
          </tbody>
        </table>
      </div>
    </div>
  @endif

  @if(!empty($pirep->simbrief))
    <div class="separator"></div>
    <div class="row mt-5">
      <div class="col-12">
        <div class="form-container">
          <h6><i class="fas fa-info-circle"></i>
            &nbsp;OFP
          </h6>
          <div class="form-container-body border border-dark">
            <div class="overflow-auto" style="height: 600px;">
              {!! $pirep->simbrief->xml->text->plan_html !!}
            </div>
          </div>
        </div>
      </div>
    </div>
  @endif
@endsection

resources/views/layouts/default/pireps/table.blade.php
<div class="table-responsive">
  <table class="table table-hover table-striped">
    <thead>
    <tr>
      <th>{{ trans_choice('common.flight', 1) }}</th>
      <th>@lang('common.departure')</th>
      <th>@lang('common.arrival')</th>
      <th>@lang('common.aircraft')</th>
      <th class="text-center">@lang('flights.flighttime')</th>
      <th class="text-center">@lang('common.status')</th>
      <th>@lang('pireps.submitted')</th>
      <th></th>
    </tr>
    </thead>
    <tbody>

    @foreach($pireps as $pirep)
      <tr>
        <td>
          <a href="{{ route('frontend.pireps.show', [
                      $pirep->id]) }}">{{ $pirep->airline->code }}{{ $pirep->ident }}</a>
        </td>
        <td>
          @if($pirep->dpt_airport){{ $pirep->dpt_airport->name }}@endif
                  (<a href="{{route('frontend.airports.show', [$pirep->dpt_airport_id])}}">{{$pirep->dpt_airport_id}}</a>)
        </td>
        <td>
          @if($pirep->arr_airport){{ $pirep->arr_airport->name }}@endif
                  (<a href="{{route('frontend.airports.show', [$pirep->arr_airport_id])}}">{{$pirep->arr_airport_id}}</a>)
        </td>
        <td>
          @if($pirep->aircraft)
            {{ optional($pirep->aircraft)->name }}
          @else
            -
          @endif
        </td>
        <td class="text-center">
          @minutestotime($pirep->flight_time)
        </td>
        <td class="text-center">
          @php
            $color = 'badge-info';
            if($pirep->state === PirepState::PENDING) {
                $color = 'badge-warning';
            } elseif ($pirep->state === PirepState::ACCEPTED) {
                $color = 'badge-success';
            } elseif ($pirep->state === PirepState::REJECTED) {
                $color = 'badge-danger';
            }
          @endphp
          <div class="badge {{ $color }}">{{ PirepState::label($pirep->state) }}</div>
        </td>
        <td>
          @if(filled($pirep->submitted_at))
            {{ $pirep->submitted_at->diffForHumans() }}
          @endif
        </td>
        <td>
          @if(!$pirep->read_only)
            <a href="{{ route('frontend.pireps.edit', [$pirep->id]) }}"
               class="btn btn-outline-info btn-sm"
               style="z-index: 9999"
               title="@lang('common.edit')">
              @lang('common.edit')
            </a>
          @endif
        </td>
      </tr>
    @endforeach

    </tbody>
  </table>
</div>